// More information about this indicator can be found at:
// http://fxcodebase.com/code/viewtopic.php?f=38&t=71267

//+------------------------------------------------------------------------+
//|                                    Copyright © 2021, Gehtsoft USA LLC  | 
//|                                                 http://fxcodebase.com  |
//+------------------------------------------------------------------------+
//|                                      Support our efforts by donating   | 
//|                                         Paypal: https://goo.gl/9Rj74e  |
//+------------------------------------------------------------------------+
//|                                           Developed by : Mario Jemic   |                    
//|                                               mario.jemic@gmail.com    |
//|                                https://AppliedMachineLearning.systems  |
//|                                     Patreon :  https://goo.gl/GdXWeN   |  
//+------------------------------------------------------------------------+

#property copyright "Copyright © 2021, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"
#property version   "1.2"
#property strict

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 clrLime
#property indicator_width1 2
#property indicator_label1 "Buy"
#property indicator_color2 clrRed
#property indicator_width2 2
#property indicator_label2 "Sell"

double ExtBuffer01[], ExtBuffer02[];
extern int FasterMovingAverage = 5;
extern int SlowerMovingAverage = 12;
extern int RSIPeriod = 12;
extern int MagicFilterPeriod = 1;
extern int BollingerbandsPeriod = 10;
extern int BollingerbandsShift = 0;
extern double BollingerbandsDeviation = 0.5;
extern int BullsPowerPeriod = 50;
extern int BearsPowerPeriod = 50;
extern bool Alerts = TRUE;
extern int Utstup = 10;
extern int UpArrowCode = 233;
extern int DownArrowCode = 234;
// More templates and snippets on https://github.com/sibvic/mq4-templates
input string   AlertsSection            = ""; // == Alerts ==
input bool     popup_alert              = false; // Popup message
input bool     notification_alert       = false; // Push notification
input bool     email_alert              = false; // Email
input bool     play_sound               = false; // Play sound on alert
input string   sound_file               = ""; // Sound file
input bool     start_program            = false; // Start external program
input string   program_path             = ""; // Path to the external program executable
input bool     advanced_alert           = false; // Advanced alert (Telegram/Discord/other platform (like another MT4))
input string   advanced_key             = ""; // Advanced alert key
input string   Comment2                 = "- You can get a key via @profit_robots_bot Telegram Bot. Visit ProfitRobots.com for discord/other platform keys -";
input string   Comment3                 = "- Allow use of dll in the indicator parameters window -";
input string   Comment4                 = "- Install AdvancedNotificationsLib.dll -";
//template code start1; copy and paste
extern string             button_note1          = "------------------------------";
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER;                 //chart btn_corner for anchoring
extern string             btn_text              = "Arrow";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;                                //btn__font size
extern color              btn_text_ON_color     = clrWhite;
extern color              btn_text_OFF_color    = clrRed;
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 20;                                //btn__x
extern int                button_y              = 13;                                //btn__y
extern int                btn_Width             = 60;                                //btn__width
extern int                btn_Height            = 20;                                //btn__height
extern string             button_note2          = "------------------------------";
//button_note1,btn_corner,btn_text,btn_Font,btn_FontSize,btn_text_ON_color,btn_text_OFF_color,btn_background_color,btn_border_color,button_x,button_y,btn_Width,btn_Height,button_note2,
bool                      show_data             = true;
string IndicatorName, IndicatorObjPrefix, buttonId;
//template code end1
//int Forex02 = 0;
bool UpArrow01 = FALSE;
bool UpArrow02 = FALSE;
bool UpArrow03 = FALSE;
bool UpArrow04 = FALSE;
bool UpArrow05 = FALSE;
bool DownArrow01 = FALSE;
bool DownArrow02 = FALSE;
bool DownArrow03 = FALSE;
bool DownArrow04 = FALSE;
bool DownArrow05 = FALSE;
int Forex01 = 0;
bool Semafor01 = FALSE;
bool Semafor02 = FALSE;
//+------------------------------------------------------------------------------------------------------------------+
string GenerateIndicatorName(const string target) //don't change anything in this function
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//+------------------------------------------------------------------------------------------------------------------+
int OnInit()  //don't forget to change buttonId name
{
   IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName);
   IndicatorDigits(Digits);
   
   double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0;

   ChartSetInteger(ChartID(), CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix + "SuperArrow";                 //don't forget to change name here
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_XDISTANCE, button_x);

// put init() here
   init2();
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------------------------------------------------------+
//don't change anything in this function
void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (ChartID(),buttonID);
      ObjectCreate    (ChartID(),buttonID,OBJ_BUTTON,0,0,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (ChartID(),buttonID,OBJPROP_FONT,font);
      ObjectSetString (ChartID(),buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YDISTANCE,9999);
}
//+------------------------------------------------------------------------------------------------------------------+
int deinit()
{
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);

   //put deinit() here
	return(0);
}
//+------------------------------------------------------------------------------------------------------------------+
//don't change anything in this function
bool recalc = true;

void handleButtonClicks()
{
   if (ObjectGetInteger(ChartID(), buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(ChartID(), buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
//+------------------------------------------------------------------------------------------------------------------+
void OnChartEvent(const int id, //don't change anything in this function
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
}
//+------------------------------------------------------------------------------------------------------------------+
int start()
{
   handleButtonClicks();
   recalc = false;
   
      if (show_data)
         {
          ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color);
          init2();
          start2();
         }
      else
         {
          ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
          for (int banzai=0; banzai<indicator_buffers; banzai++)
              SetIndexStyle(banzai,DRAW_NONE);
          deinit2();
         }
   return(0);
}
//+------------------------------------------------------------------------------------------------------------------+

// AdvancedNotificationsLib.dll could be downloaded here: http://profitrobots.com/Home/TelegramNotificationsMT4
#import "AdvancedNotificationsLib.dll"
void AdvancedAlert(string key, string text, string instrument, string timeframe);
#import
#import "shell32.dll"
int ShellExecuteW(int hwnd,string Operation,string File,string Parameters,string Directory,int ShowCmd);
#import

class Signaler
{
   string _prefix;
public:
   Signaler()
   {
   }

   void SetMessagePrefix(string prefix)
   {
      _prefix = prefix;
   }

   void SendNotifications(const string subject, string message = NULL)
   {
      if (message == NULL)
         message = subject;
      if (_prefix != "" && _prefix != NULL)
         message = _prefix + message;

      if (start_program)
         ShellExecuteW(0, "open", program_path, "", "", 1);
      if (popup_alert)
         Alert(message);
      if (email_alert)
         SendMail(subject, message);
      if (play_sound)
         PlaySound(sound_file);
      if (notification_alert)
         SendNotification(message);
      if (advanced_alert && advanced_key != "" && !IsTesting())
         AdvancedAlert(advanced_key, message, "", "");
   }
};
Signaler* signaler;

string TimeframeToString(ENUM_TIMEFRAMES tf)
{
   switch (tf)
   {
      case PERIOD_CURRENT: return TimeframeToString((ENUM_TIMEFRAMES)_Period);
      case PERIOD_M1: return "M1";
      case PERIOD_M5: return "M5";
      case PERIOD_D1: return "D1";
      case PERIOD_H1: return "H1";
      case PERIOD_H4: return "H4";
      case PERIOD_M15: return "M15";
      case PERIOD_M30: return "M30";
      case PERIOD_MN1: return "MN1";
      case PERIOD_W1: return "W1";
   }
   return "";
}

// E37F0136AA3FFAF149B351F6A4C948E9
int init2() {
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, UpArrowCode);
   SetIndexBuffer(0, ExtBuffer01);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, DownArrowCode);
   SetIndexBuffer(1, ExtBuffer02);
   signaler = new Signaler();
   signaler.SetMessagePrefix(_Symbol + "/" + TimeframeToString((ENUM_TIMEFRAMES)_Period) + ": ");

   return (0);
}

// 52D46093050F38C27267BCE42543EF60
int deinit2() {
   delete signaler;
   return (0);
}

// EA2B2676C28C0DB26D39331A336C6B92
int start2() {
   int pos;
   double MovingAverages01;
   double MovingAverages03;
   double MovingAverages02;
   double MovingAverages04;
   double MainRSI01;
   double MainRSI02;
   double BullsPower01;
   double BullsPower02;
   double BearsPower01;
   double BearsPower02;
   double HighestPt01;
   double HighestPt02;
   double tempNumber01;
   double tempNumber02;
   double Numero01;
   double Numero02;
   double MainArrow01;
   double BollingerBand01;
   double BollingerBand02;
   double BollingerBand03;
   double BollingerBand04;
//   int Li_148 = IndicatorCounted();
//   if (Li_148 < 0) return (-1);
//   if (Li_148 > 0) Li_148--;
//   int Limit = Bars - Li_148 - 11;
   int Limit = Bars - 11;

   for (int counter01 = 0; counter01 <= Limit; counter01++) {
      Numero02 = 0;
      MainArrow01 = 0;
      for (pos = counter01; pos <= counter01 + 10; pos++) 
      {
         MainArrow01 += MathAbs(High[pos] - Low[pos]);
      }
      Numero02 = MainArrow01 / 10.0;
      MovingAverages01 = iMA(NULL, 0, FasterMovingAverage, 0, MODE_EMA, PRICE_CLOSE, counter01);
      MovingAverages02 = iMA(NULL, 0, FasterMovingAverage, 0, MODE_EMA, PRICE_CLOSE, counter01 + 1);
      MovingAverages03 = iMA(NULL, 0, SlowerMovingAverage, 0, MODE_EMA, PRICE_CLOSE, counter01);
      MovingAverages04 = iMA(NULL, 0, SlowerMovingAverage, 0, MODE_EMA, PRICE_CLOSE, counter01 + 1);
      MainRSI01 = iRSI(NULL, 0, RSIPeriod, PRICE_CLOSE, counter01);
      MainRSI02 = iRSI(NULL, 0, RSIPeriod, PRICE_CLOSE, counter01 + 1);
      BullsPower01 = iBullsPower(NULL, 0, BullsPowerPeriod, PRICE_CLOSE, counter01);
      BullsPower02 = iBullsPower(NULL, 0, BullsPowerPeriod, PRICE_CLOSE, counter01 + 1);
      BearsPower01 = iBearsPower(NULL, 0, BearsPowerPeriod, PRICE_CLOSE, counter01);
      BearsPower02 = iBearsPower(NULL, 0, BearsPowerPeriod, PRICE_CLOSE, counter01 + 1);
      BollingerBand01 = iBands(NULL, 0, BollingerbandsPeriod, BollingerbandsDeviation, BollingerbandsShift, PRICE_CLOSE, MODE_UPPER, counter01);
      BollingerBand02 = iBands(NULL, 0, BollingerbandsPeriod, BollingerbandsDeviation, BollingerbandsShift, PRICE_CLOSE, MODE_LOWER, counter01);
      BollingerBand03 = iBands(NULL, 0, BollingerbandsPeriod, BollingerbandsDeviation, BollingerbandsShift, PRICE_CLOSE, MODE_UPPER, counter01 + 1);
      BollingerBand04 = iBands(NULL, 0, BollingerbandsPeriod, BollingerbandsDeviation, BollingerbandsShift, PRICE_CLOSE, MODE_LOWER, counter01 + 1);
      HighestPt01 = iHighest(NULL, 0, MODE_HIGH, MagicFilterPeriod, counter01);
      HighestPt02 = iHighest(NULL, 0, MODE_LOW, MagicFilterPeriod, counter01);
      tempNumber01 = 100 - 100.0 * ((HighestPt01 - 0.0) / 10.0);
      tempNumber02 = 100 - 100.0 * ((HighestPt02 - 0.0) / 10.0);
      if (tempNumber01 == 0.0) tempNumber01 = 0.0000001;
      if (tempNumber02 == 0.0) tempNumber02 = 0.0000001;
      Numero01 = tempNumber01 - tempNumber02;
      if (Numero01 >= 0.0) {
         UpArrow05 = TRUE;
         DownArrow05 = FALSE;
      } else {
         if (Numero01 < 0.0) {
            UpArrow05 = FALSE;
            DownArrow05 = TRUE;
         }
      }
      if (Close[counter01] > BollingerBand01 && Close[counter01 + 1] >= BollingerBand03) {
         UpArrow04 = FALSE;
         DownArrow04 = TRUE;
      }
      if (Close[counter01] < BollingerBand02 && Close[counter01 + 1] <= BollingerBand04) {
         UpArrow04 = TRUE;
         DownArrow04 = FALSE;
      }
      if (BullsPower01 > 0.0 && BullsPower02 > BullsPower01) {
         UpArrow03 = FALSE;
         DownArrow03 = TRUE;
      }
      if (BearsPower01 < 0.0 && BearsPower02 < BearsPower01) {
         UpArrow03 = TRUE;
         DownArrow03 = FALSE;
      }
      if (MainRSI01 > 50.0 && MainRSI02 < 50.0) {
         UpArrow02 = TRUE;
         DownArrow02 = FALSE;
      }
      if (MainRSI01 < 50.0 && MainRSI02 > 50.0) {
         UpArrow02 = FALSE;
         DownArrow02 = TRUE;
      }
      if (MovingAverages01 > MovingAverages03 && MovingAverages02 < MovingAverages04) {
         UpArrow01 = TRUE;
         DownArrow01 = FALSE;
      }
      if (MovingAverages01 < MovingAverages03 && MovingAverages02 > MovingAverages04) {
         UpArrow01 = FALSE;
         DownArrow01 = TRUE;
      }
      if (UpArrow01 == TRUE && UpArrow02 == TRUE && UpArrow04 == TRUE && UpArrow03 == TRUE && UpArrow05 == TRUE && Forex01 != 1) {
         ExtBuffer01[counter01] = Low[counter01] - (Point * Utstup); //1.3 * Numero02;
         if (counter01 <= 2 && Alerts && (!Semafor01)) {
            Alert(Symbol(), " ", Period(), "   BUY");
            signaler.SendNotifications("BUY");
            Semafor01 = TRUE;
            Semafor02 = FALSE;
         }
         Forex01 = 1;
      } else {
         if (DownArrow01 == TRUE && DownArrow02 == TRUE && DownArrow04 == TRUE && DownArrow03 == TRUE && DownArrow05 == FALSE && Forex01 != 2) {
            ExtBuffer02[counter01] = High[counter01] + (Point * Utstup); // 1.3 * Numero02;
            if (counter01 <= 2 && Alerts && (!Semafor02)) {
               Alert(Symbol(), " ", Period(), "   SELL");
               signaler.SendNotifications("SELL");
               Semafor02 = TRUE;
               Semafor01 = FALSE;
            }
            Forex01 = 2;
         }
      }
   }
   return (0);
}
